package db;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

public class PercentOfMissingData {

	public Database db = Database.getInstance();
	
	public int[] maxTS(int ts_id) {
		int[] selects = new int[3];
//		System.out.println("Reading data from " + ts_id + " starts ....");
		
		try {
			Connection conn = db.newConnection();

			if (conn==null) {
				System.out.println("Connection null");
				return null;
			}
			String tsQuery = "select  max(ts) as maxts, count(ts) as countts from observation o where series_id = ?";
			PreparedStatement tsStmt= conn.prepareStatement(tsQuery);
			tsStmt.setInt(1, ts_id);
			ResultSet tsRs = tsStmt.executeQuery();
//			tsStmt.close();

			if(tsRs.next()) {
			selects[0] = tsRs.getInt(1);
			selects[1] = tsRs.getInt(2);
			} 
			
//			String tsQuery2 = "SELECT granul FROM series WHERE id = ?";
//			PreparedStatement tsStmt2= conn.prepareStatement(tsQuery2);
//			tsStmt2.setInt(1, ts_id);
//			ResultSet tsRs2 = tsStmt2.executeQuery();
////			tsStmt.close();
//
//			if(tsRs2.next()) {
			if(ts_id < 179) {
				selects[2] = 2;
			} else {
				selects[2] = 1;
			}
				
//			} 
			
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}

		return selects;
	}
	
	public double countPercentage(int ts_id) {

			int[] sel = maxTS(ts_id);
			double whole = sel[0]/sel[2];
			double percentOfExists = sel[1]/whole;
//			System.out.println("Percent of missing for ts_id: " + ts_id + " is: " + (1-percentOfExists));
			return (1-percentOfExists);
		
	}
	
	public double iterate() {
		double sum = 0;
		double result = 0;
		for(int i = 100; i < 318; i++) {
			if(i == 269 && i == 267) {
				sum += 0;
			}
			else {
			double percentOfMissing = countPercentage(i);
			System.out.println("percentOfMissing for i: " + i + " is: " + percentOfMissing);
			sum += percentOfMissing;
			System.out.println("sum: " + sum);
			}
		}
		result = sum/217;
		System.out.println("Percentage of missing values: " + result);
		return result;
	}
	
	public double iterateTemp() {
		double sum = 0;
		double result = 0;
		for(int i = 100; i < 179; i++) {
			if(i == 269 && i == 267) {
				sum += 0;
			}
			else {
			double percentOfMissing = countPercentage(i);
//			System.out.println("percentOfMissing for i: " + i + " is: " + percentOfMissing);
			sum += percentOfMissing;
//			System.out.println("sum: " + sum);
			}
		}
		result = sum/79;
		System.out.println("Percentage of missing values in temperature set: " + result);
		return result;
	}
	
	public double iterateHum() {
		double sum = 0;
		double result = 0;
		for(int i = 179; i < 194; i++) {
			if(i == 269 && i == 267) {
				sum += 0;
			}
			else {
			double percentOfMissing = countPercentage(i);
//			System.out.println("percentOfMissing for i: " + i + " is: " + percentOfMissing);
			sum += percentOfMissing;
//			System.out.println("sum: " + sum);
			}
		}
		result = sum/15;
		System.out.println("Percentage of missing values in humidity set: " + result);
		return result;
	}
	
	public double iterateWind() {
		double sum = 0;
		double result = 0;
		for(int i = 194; i < 198; i++) {
			if(i == 269 && i == 267) {
				sum += 0;
			}
			else {
			double percentOfMissing = countPercentage(i);
//			System.out.println("percentOfMissing for i: " + i + " is: " + percentOfMissing);
			sum += percentOfMissing;
//			System.out.println("sum: " + sum);
			}
		}
		result = sum/4;
		System.out.println("Percentage of missing values in wind speed set: " + result);
		return result;
	}
	
	public double iteratePrecip() {
		double sum = 0;
		double result = 0;
		for(int i = 198; i < 267; i++) {
			if(i == 269 && i == 267) {
				sum += 0;
			}
			else {
			double percentOfMissing = countPercentage(i);
//			System.out.println("percentOfMissing for i: " + i + " is: " + percentOfMissing);
			sum += percentOfMissing;
//			System.out.println("sum: " + sum);
			}
		}
		result = sum/69;
		System.out.println("Percentage of missing values in precipiation set: " + result);
		return result;
	}
	

	public double iterateAir() {
		double sum = 0;
		double result = 0;
		for(int i = 267; i < 270; i++) {
			if(i == 269 && i == 267) {
				sum += 0;
			}
			else {
			double percentOfMissing = countPercentage(i);
//			System.out.println("percentOfMissing for i: " + i + " is: " + percentOfMissing);
			sum += percentOfMissing;
//			System.out.println("sum: " + sum);
			}
		}
		result = sum/1;
		System.out.println("Percentage of missing values in air pressure set: " + result);
		return result;
	}
	

	public double iterateWater() {
		double sum = 0;
		double result = 0;
		for(int i = 270; i < 318; i++) {
			if(i == 269 && i == 267) {
				sum += 0;
			}
			else {
			double percentOfMissing = countPercentage(i);
//			System.out.println("percentOfMissing for i: " + i + " is: " + percentOfMissing);
			sum += percentOfMissing;
//			System.out.println("sum: " + sum);
			}
		}
		result = sum/48;
		System.out.println("Percentage of missing values in water level set: " + result);
		return result;
	}
	
	public static void main(String[] args) {
		PercentOfMissingData pomd = new PercentOfMissingData();
		pomd.iterateTemp();
		pomd.iterateHum();
		pomd.iterateWind();
		pomd.iteratePrecip();
		pomd.iterateAir();
		pomd.iterateWater();
	}
	
}
