package gui;

import io.ReadFromFile;

import java.awt.Color;
import java.io.File;

import cede.Matrix;

import db.DataLoader;

/**
 * Controller responsible for the decomposition tab.
 *
 */

public class DecompositionController {

	DataLoader loader = DataLoader.getInstance();
	BottomPanel bottomPanel;
	FileChooserPanel filechooserPanel;



	public void decomp(File file) {
		ReadFromFile rf = new ReadFromFile(this, file);

		try {
			rf.readAndDecompose();
			log("Decomposition is done.", Color.BLUE);

			rf.save();
			Matrix v = rf.getFactorMatrix();
			Matrix b = rf.getLoadingMatrix();
			
			double currentMemory = ( (double)((double)(Runtime.getRuntime().totalMemory()/1024)/1024))- ((double)((double)(Runtime.getRuntime().freeMemory()/1024)/1024));
			System.out.print(currentMemory);
			
			filechooserPanel.factorMatrix.setText(v.toString());
			filechooserPanel.loadingMatrix.setText(b.toString());
			
			
			log("Result of the decomposition is saved in \"decomposition.txt\" file.", Color.BLUE);

		} catch (NumberFormatException e) {
			log("Invalid input format!" , Color.red);
		}

	}

	public void setBottomPanel(BottomPanel bottomPanel) {
		this.bottomPanel = bottomPanel;
	}

	public BottomPanel getBottomPanel() {
		return bottomPanel;
	}

	public FileChooserPanel getFilechooserPanel() {
		return filechooserPanel;
	}

	public void setFilechooserPanel(FileChooserPanel filechooserPanel) {
		this.filechooserPanel = filechooserPanel;
	}

	public void log(String text, Color color) {
		bottomPanel.appendLogText(text, color);
	}


}
