package gui;

import java.awt.Color;
import java.util.ArrayList;
import java.util.HashSet;

import javax.swing.JOptionPane;

import org.jfree.ui.RefineryUtilities;

import db.DataLoader;

public class DisplayController {

	DataLoader loader = DataLoader.getInstance();
	DisplayTabPanel displayTabPanel;
	DisplayTopPanel displayTopPanel;
	BottomPanel bottomPanel;
	TableOfSets setTable;
	JTablePanel tsTable;
	
	
	ArrayList<Integer> timeseriesList = new ArrayList<Integer>();
	
	public DisplayController() {
		loader.setDc(this);
	}
	
	
	public void updateTimeSeries(String ts_id) {	
		timeseriesList.add(Integer.parseInt(ts_id));
		removeDuplicates();
		if(!checkNumber()) {
			timeseriesList.remove((Object)Integer.parseInt(ts_id));
			log( "Maximal number of timeseries can be chosen is 10!", Color.RED);
		} else {
			
			StringBuffer buff = new StringBuffer();
			for(Integer i: timeseriesList) {
				buff.append(Integer.toString(i) + ", ");
			}
			String text = buff.toString();
			displayTopPanel.label2.setText(text);
		}
	}
	
	public void removeDuplicates() {
		//Create a hashSet from the ArrayList because it's removes the duplicate items
		  HashSet<Integer> hashSet = new HashSet<Integer>(timeseriesList);

		  //Then create a new list from the hashset
		  ArrayList<Integer> list = new ArrayList<Integer>(hashSet) ;
		  
		  
		  if(timeseriesList.size() != list.size()) {
			  timeseriesList.clear();
			  timeseriesList = list;
		  }
		  
	}
	
	public void displaylog() {
		log("Display chart is starting...", Color.BLUE);
	}
	
	public void setSelected(int setID) {
		displayTabPanel.refreshTsTable(setID);
	}
	
	public boolean checkNumber() {
		if(timeseriesList.size() > 10) {			
			return false;
		} else
			return true;
	}
	
	public void reset() {
		timeseriesList.clear();
		displayTopPanel.label2.setText("");
		bottomPanel.log.setText("");
	}
	
	public void display() {
		SliderFrame demo = new SliderFrame("Hydrological Time Series", timeseriesList, "display", -1, -1);
        demo.pack();
        RefineryUtilities.centerFrameOnScreen(demo);
        demo.setVisible(true);
	}

	public DisplayTabPanel getDisplayTabPanel() {
		return displayTabPanel;
	}

	public void setDisplayTabPanel(DisplayTabPanel displayTabPanel) {
		this.displayTabPanel = displayTabPanel;
	}

	public DisplayTopPanel getDisplayTopPanel() {
		return displayTopPanel;
	}

	public void setDisplayTopPanel(DisplayTopPanel displayTopPanel) {
		this.displayTopPanel = displayTopPanel;
	}

	public BottomPanel getBottomPanel() {
		return bottomPanel;
	}

	public void setBottomPanel(BottomPanel bottomPanel) {
		this.bottomPanel = bottomPanel;
	}
	
	public void log(String text, Color color) {
		bottomPanel.appendLogText(text, color);
	}

	public void setSetTable(TableOfSets setTable) {
		this.setTable = setTable;
	}

	public void setTsTable(JTablePanel tsTable) {
		this.tsTable = tsTable;
	}


	
}
