package gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.util.ArrayList;

import javax.swing.JPanel;

import model.TimeSeries;

import db.DataLoader;

public class DisplayTabPanel extends JPanel{

	private DisplayController dc;
	private Controller c;
	private DataLoader loader = DataLoader.getInstance();
	JTablePanel tsTable;
	ArrayList<TimeSeries> listTemp;
	ArrayList<TimeSeries> listHum;
	ArrayList<TimeSeries> listPrecip;
	ArrayList<TimeSeries> listWind;
	ArrayList<TimeSeries> listAir;
	ArrayList<TimeSeries> listWater;

	public DisplayTabPanel(Controller c, DisplayController dc) {
		super(new BorderLayout());
		this.c = c;
		this.dc = dc;
		dc.setDisplayTabPanel(this);
		initUI();
	}
	
	public void initUI() {
		setSize(1101, 740);
		getDataFromDB();
//		JPanel center = new CenterPanel(listTemp, listHum, listPrecip, listWind, listAir, listWater, c);
		TableOfSets setTable = new TableOfSets(dc);
		tsTable = new JTablePanel(100, dc);
		DisplayTopPanel top = new DisplayTopPanel(dc);
		JPanel center = new JPanel();
		center.setLayout(new GridLayout(1,2));
		BottomPanel bottom = new BottomPanel();
		dc.setBottomPanel(bottom);
		add(top, BorderLayout.NORTH);
		center.add(setTable);
		center.add(tsTable);
		add(center, BorderLayout.CENTER);
		add(bottom, BorderLayout.SOUTH);

		
	}

	public void getDataFromDB() {

		listTemp= loader.selectTimeSeriesFromSet(100);
		listHum= loader.selectTimeSeriesFromSet(101);
		listPrecip= loader.selectTimeSeriesFromSet(103);
		listWind= loader.selectTimeSeriesFromSet(102);
		listAir= loader.selectTimeSeriesFromSet(104);
		listWater= loader.selectTimeSeriesFromSet(105);
	}
	
	public void refreshTsTable(int setID) {
		this.tsTable.initTable(setID);
	}
	
}
