package gui;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


/**
 * File chooser.
 *
 */

public class FileChooserPanel extends JPanel implements ActionListener {

	static private final String newline = "\n";

	DecompositionController dc;
	File file;

	JLabel label;
	JTextArea instructions;
	JTextArea factorMatrix;
	JTextArea loadingMatrix;
	JLabel label_factorMatrix;
	JLabel label_loadingMatrix;
	JButton openButton;
	JButton decomposeButton;
	JFileChooser fc;


	public FileChooserPanel(DecompositionController dc) {
		super();
		setLayout(null);
		this.dc = dc;


		//Create a file chooser
		fc = new JFileChooser();
		//fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		//fc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);

		//create labels
		label = new JLabel("Browse for your file contains input matrix!");
		label.setForeground(Color.BLUE);
		
		instructions = new JTextArea();
		Font font = new Font("Monaco", Font.PLAIN, 11);
		instructions.setFont(font);
		instructions.append("Constraints: \n");
		instructions.append("You must store your matrix in a file with extension \".txt\". \n");
		instructions.append("The first line of your input file should contain only 2 integers separated by a comma \",\" . These two numbers characterise your input matrix: \n");
		instructions.append("the first means the number of rows, the second means the number of columns. \n");
		instructions.append("From the second line on you can start define your matrixm each element as a float. The elements should be separated by commas \",\", the rows should be separated with a new line.");
		
		
		label_factorMatrix = new JLabel("Obtained matrix V: ");
		label_loadingMatrix = new JLabel("Obtained matrix B: ");
		
		factorMatrix = new JTextArea();
		factorMatrix.setEditable(false);
		loadingMatrix = new JTextArea();
		loadingMatrix.setEditable(false);
		
		
		//create buttons
		openButton = new JButton("Open a File...");
		openButton.addActionListener(this);
		

		decomposeButton = new JButton("Decompose");
		decomposeButton.addActionListener(this);
		

		add(label);
		label.setBounds(10, 40, 280, 20);
		
		add(openButton);
		openButton.setBounds(300, 40, 100, 20);
		
		add(decomposeButton);
		decomposeButton.setBounds(420, 40, 100, 20);

		add(instructions);
		instructions.setBounds(0, 70, 1101, 90);
		
		
		
		add(label_factorMatrix);
		label_factorMatrix.setBounds(10, 170, 400, 20);
		
		add(label_loadingMatrix);
		label_loadingMatrix.setBounds(560, 170, 400, 20);
		
		JScrollPane scrollPaneFactor = new JScrollPane(factorMatrix);
		add(scrollPaneFactor);
		scrollPaneFactor.setBounds(5, 200, 540, 400);
		
		JScrollPane scrollPaneLoading = new JScrollPane(loadingMatrix);
		add(scrollPaneLoading);
		scrollPaneLoading.setBounds(555, 200, 540, 400);
		
		
	}



	public void actionPerformed(ActionEvent e) {

		//Handle open button action.
		if (e.getSource() == openButton) {
			int returnVal = fc.showOpenDialog(FileChooserPanel.this);

			if (returnVal == JFileChooser.APPROVE_OPTION) {
				file = fc.getSelectedFile();
		
				dc.log("Input file " + file.getName() + " is loaded." + newline, Color.BLUE);
			} else {
				dc.log("Open command cancelled by user." + newline , Color.BLUE);
			}


			//Handle decomposition button action.
		} 
		else if (e.getSource() == decomposeButton) {
			dc.decomp(file);
		}
	}
}