package gui;

import java.awt.*;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;
import javax.swing.border.EtchedBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import db.DataLoader;

import model.TimeSeries;

import java.util.ArrayList;
import java.util.Vector;



public class TopPanel extends JPanel implements ActionListener {

	Controller controller;
	DataLoader loader = DataLoader.getInstance();

	ArrayList<TimeSeries> listTemp;
	ArrayList<TimeSeries> listHum;
	ArrayList<TimeSeries> listPrecip;
	ArrayList<TimeSeries> listWind;
	ArrayList<TimeSeries> listAir;
	ArrayList<TimeSeries> listWater;

	JLabel tsid;
	JLabel tsidLabel;
	JTextField tf_windowStart;
	JTextField tf_windowEnd;
	JLabel tf_timeSeriesList;
	JLabel windowStartLabel;
	JLabel windowEndLabel;
	JLabel label;
	JLabel lastTimeStamp;
	JLabel labeltemp2;
	JLabel labelhum2;
	JLabel labelwind2;
	JLabel labelair2;
	JLabel labelprec2;
	JLabel labelwater2;
	JButton buttonPreProcess;
	JButton buttonRecover;
	JButton buttonReset;
	JButton buttonDelete;
	JButton buttonFind;
	JButton buttonDisplay;
	JRadioButton rbPartly;
	JRadioButton rbTestTs;
	JRadioButton rbFind;
	JRadioButton rbWhole;
	JPanel topright;
	JComboBox temp1;
	JComboBox hum1;
	JComboBox prec1;
	JComboBox wind1;
	JComboBox air1;
	JComboBox water1;
	JComboBox temp2;
	JComboBox hum2;
	JComboBox prec2;
	JComboBox wind2;
	JComboBox air2;
	JComboBox water2;

	public TopPanel(final Controller controller) {

		super(new FlowLayout());
		this.controller = controller;
		setPreferredSize(new Dimension(1101, 590));

		//create textfields

		tf_windowStart = new JTextField(10);
		tf_windowStart.setEnabled(false);
		tf_windowEnd = new JTextField(10);
		tf_windowEnd.setEnabled(false);

		tf_timeSeriesList = new JLabel();
		tf_timeSeriesList.setEnabled(false);
		
		//create labels for topleft panel
		tsid = new JLabel();
		tsid.setEnabled(false);
		tsid.setVisible(false);
		label = new JLabel();
		label.setVisible(false);
		lastTimeStamp = new JLabel();
		lastTimeStamp.setVisible(false);
		tsidLabel = new JLabel("Select reference time series from the list below!");
		tsidLabel.setForeground(Color.BLUE);

		//create labels for bottomleftpanel
		windowStartLabel = new JLabel("start timestamp: ");
		windowStartLabel.setEnabled(false);
		windowEndLabel = new JLabel("end timestamp: ");
		windowEndLabel.setEnabled(false);

		//create comboboxes
		temp1 = createComboBox(100);
		temp1.setActionCommand("ref");
		hum1 = createComboBox(101);
		hum1.setActionCommand("ref");
		wind1 = createComboBox(102);
		wind1.setActionCommand("ref");
		prec1 = createComboBox(103);
		prec1.setActionCommand("ref");
		air1 = createComboBox(104);
		air1.setActionCommand("ref");
		water1 = createComboBox(105);
		water1.setActionCommand("ref");
		temp2 = createComboBox(100);
		temp2.setActionCommand("test");
		temp2.setEnabled(false);
		hum2 = createComboBox(101);
		hum2.setActionCommand("test");
		hum2.setEnabled(false);
		wind2 = createComboBox(102);
		wind2.setActionCommand("test");
		wind2.setEnabled(false);
		prec2 = createComboBox(103);
		prec2.setActionCommand("test");
		prec2.setEnabled(false);
		air2 = createComboBox(104);
		air2.setActionCommand("test");
		air2.setEnabled(false);
		water2 = createComboBox(105);
		water2.setActionCommand("test");
		water2.setEnabled(false);

		//create buttons
		buttonReset = new JButton("Restart");
		buttonReset.setVisible(false);
		buttonReset.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				clean();
			}
		});

		//create displaybutton
		
		buttonDisplay = new JButton("Display results");
		buttonDisplay.setVisible(false);
		buttonDisplay.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				int ts_id_recov = Integer.parseInt(tsid.getText());
				controller.display(ts_id_recov);
			}
		});
		
		//create buttons
		buttonDelete = new JButton("Empty list");
		buttonDelete.setVisible(false);
		buttonDelete.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				controller.deleteTestTs();
				temp2.setSelectedIndex(-1);
				hum2.setSelectedIndex(-1);
				air2.setSelectedIndex(-1);
				prec2.setSelectedIndex(-1);
				wind2.setSelectedIndex(-1);
				water2.setSelectedIndex(-1);

			}
		});

		buttonFind = new JButton("Find");
		buttonFind.setEnabled(false);
		buttonFind.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				int ts_id_recov = Integer.parseInt(tsid.getText());
				controller.findCorrelated(ts_id_recov);
				
			}
		});

		buttonPreProcess = new JButton("Preprocess");
		buttonPreProcess.setEnabled(false);
		buttonPreProcess.addActionListener(new ActionListener() {			
			@Override
			public void actionPerformed(ActionEvent e) {
				int ts_id_recov = Integer.parseInt(tsid.getText());
				controller.preProcessedClicked(ts_id_recov);			
			}
		});


		buttonRecover = new JButton("Recover");
		buttonRecover.setEnabled(false);
		buttonRecover.addActionListener(new ActionListener() {			
			@Override
			public void actionPerformed(ActionEvent e) {
//				int ts_id_recov = Integer.parseInt(tsid.getText());
				controller.recover();	
			}
		});

		//		create checkbox
		rbPartly = new JRadioButton("Recover partly with ");	
		rbPartly.setEnabled(false);
		rbPartly.addChangeListener(new ChangeListener() {

			@Override
			public void stateChanged(ChangeEvent e) {	
				if(rbPartly.isSelected()) {
					rbWhole.setSelected(false);
					tf_windowStart.setEnabled(true);
					tf_windowEnd.setEnabled(true);
					buttonPreProcess.setEnabled(true);
				} else {
					tf_windowStart.setEnabled(false);
					tf_windowEnd.setEnabled(false);
				}

			}
		});

		rbWhole = new JRadioButton("Recover whole time series!");
		rbWhole.setEnabled(false);
		rbWhole.addChangeListener(new ChangeListener() {

			@Override
			public void stateChanged(ChangeEvent e) {	
				if(rbWhole.isSelected()) {
					rbPartly.setSelected(false);
					tf_windowStart.setEnabled(false);
					tf_windowEnd.setEnabled(false);
					buttonPreProcess.setEnabled(true);

				} else {

				}

			}
		});


		rbTestTs = new JRadioButton("Select test time serieses from the list below!");
		rbTestTs.setActionCommand("givetimeseries");
		rbTestTs.setEnabled(false);
		rbTestTs.addChangeListener(new ChangeListener() {

			@Override
			public void stateChanged(ChangeEvent e) {	
				if(rbTestTs.isSelected()) {					
					rbFind.setSelected(false);
					labeltemp2.setEnabled(true);
					labelhum2.setEnabled(true);
					labelwind2.setEnabled(true);
					labelprec2.setEnabled(true);
					labelair2.setEnabled(true);
					labelwater2.setEnabled(true);
					temp2.setEnabled(true);
					wind2.setEnabled(true);
					hum2.setEnabled(true);
					prec2.setEnabled(true);
					air2.setEnabled(true);
					water2.setEnabled(true);	
				} 
			}
		});

		//create radiobuttons
		rbFind = new JRadioButton("Or find correlated!");
		rbFind.setEnabled(false);
		rbFind.addChangeListener(new ChangeListener() {

			@Override
			public void stateChanged(ChangeEvent e) {	
				if(rbFind.isSelected()) {
					buttonFind.setEnabled(true);
					rbTestTs.setSelected(false);
					tf_timeSeriesList.setText("");
					controller.listClear();
					buttonPreProcess.setEnabled(false);
					labeltemp2.setEnabled(false);
					labelhum2.setEnabled(false);
					labelwind2.setEnabled(false);
					labelprec2.setEnabled(false);
					labelair2.setEnabled(false);
					labelwater2.setEnabled(false);
					temp2.setEnabled(false);
					wind2.setEnabled(false);
					hum2.setEnabled(false);
					prec2.setEnabled(false);
					air2.setEnabled(false);
					water2.setEnabled(false);	
					buttonDelete.setVisible(false);
				} else {
					buttonFind.setEnabled(false);
				}

			}
		});

		//create TOPLeft panel
		JPanel topLeft = new JPanel();
		topLeft.setPreferredSize(new Dimension(1101, 120));
		topLeft.setLayout(null);
		topLeft.add(tsidLabel);
		tsidLabel.setBounds(10, 20, 300, 22);
		topLeft.add(tsid);
		tsid.setBounds(320, 20, 30, 22);
		topLeft.add(label);
		label.setForeground(Color.DARK_GRAY);
		label.setBounds(360, 20, 250, 22);
		topLeft.add(lastTimeStamp);
		lastTimeStamp.setForeground(Color.DARK_GRAY);
		lastTimeStamp.setBounds(600, 20, 50, 22);
		JLabel labeltemp1 = new JLabel("Temperature set:");
		topLeft.add(labeltemp1);
		labeltemp1.setBounds(15, 60, 150, 20);
		topLeft.add(temp1);
		temp1.setBounds(10, 80, 150, 25);
		JLabel labelhum1 = new JLabel("Humidity set:");
		labelhum1.setBounds(188, 60, 150, 20);
		topLeft.add(labelhum1);
		topLeft.add(hum1);
		hum1.setBounds(183, 80, 150, 25);
		JLabel labelwind1 = new JLabel("Wind set:");
		topLeft.add(labelwind1);
		labelwind1.setBounds(371, 60, 150, 20);
		topLeft.add(wind1);
		wind1.setBounds(366, 80, 150, 25);
		JLabel labelprec1 = new JLabel("Precipation set:");
		topLeft.add(labelprec1);
		labelprec1.setBounds(554, 60, 150, 20);
		topLeft.add(prec1);
		prec1.setBounds(549, 80, 150, 25);
		JLabel labelair1 = new JLabel("Air set:");
		topLeft.add(labelair1);
		labelair1.setBounds(737, 60, 150, 20);
		topLeft.add(air1);
		air1.setBounds(732, 80, 150, 25);
		JLabel labelwater1 = new JLabel("Water set:");
		topLeft.add(labelwater1);
		labelwater1.setBounds(920, 60, 150, 20);
		topLeft.add(water1);
		water1.setBounds(915, 80, 150, 25);



		//create TOPRIGHT panel
		topright = new JPanel();
		topright.setPreferredSize(new Dimension(1101, 170));
		topright.setLayout(null);
		topright.add(rbTestTs);
		rbTestTs.setBounds(10, 10, 340, 22);
		topright.add(tf_timeSeriesList);
		tf_timeSeriesList.setBounds(350, 10, 200, 22);
		topright.add(buttonDelete);
		buttonDelete.setBounds(700, 10, 70, 22);
		topright.add(rbFind);
		rbFind.setBounds(10, 120, 150, 22);
		topright.add(buttonFind);
		buttonFind.setBounds(170, 120, 50, 22);
		labeltemp2 = new JLabel("Temperature set:");
		topright.add(labeltemp2);
		labeltemp2.setBounds(15, 50, 150, 20);
		labeltemp2.setEnabled(false);
		topright.add(temp2);
		temp2.setBounds(10, 70, 150, 25);
		labelhum2 = new JLabel("Humidity set:");
		labelhum2.setBounds(188, 50, 150, 20);
		labelhum2.setEnabled(false);
		topright.add(labelhum2);
		topright.add(hum2);
		hum2.setBounds(183, 70, 150, 25);
		labelwind2 = new JLabel("Wind set:");
		topright.add(labelwind2);
		labelwind2.setBounds(371, 50, 150, 20);
		labelwind2.setEnabled(false);
		topright.add(wind2);
		wind2.setBounds(366, 70, 150, 25);
		labelprec2 = new JLabel("Precipation set:");
		topright.add(labelprec2);
		labelprec2.setBounds(554, 50, 150, 20);
		labelprec2.setEnabled(false);
		topright.add(prec2);
		prec2.setBounds(549, 70, 150, 25);
		labelair2 = new JLabel("Air set:");
		topright.add(labelair2);
		labelair2.setBounds(737, 50, 150, 20);
		labelair2.setEnabled(false);
		topright.add(air2);
		air2.setBounds(732, 70, 150, 25);
		labelwater2 = new JLabel("Water set:");
		topright.add(labelwater2);
		labelwater2.setBounds(920, 50, 150, 20);
		labelwater2.setEnabled(false);
		topright.add(water2);
		water2.setBounds(915, 70, 150, 25);


		//designPanel
		
		JPanel designPanel3 = new JPanel();
		designPanel3.setPreferredSize(new Dimension(1101, 15));
		designPanel3.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		
		JPanel designPanel2 = new JPanel();
		designPanel2.setPreferredSize(new Dimension(1101, 15));
		designPanel2.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		
		JPanel designPanel1 = new JPanel();
		designPanel1.setPreferredSize(new Dimension(1101, 15));
		designPanel1.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));

		//BOTTOMLEFTPANEL
		JPanel bottomLeft = new JPanel();
		bottomLeft.setPreferredSize(new Dimension(1101, 120));
		bottomLeft.setLayout(null);
		bottomLeft.add(rbWhole);
		rbWhole.setBounds(10, 25, 300, 22);
		bottomLeft.add(rbPartly);
		rbPartly.setBounds(10, 70, 156, 22);
		bottomLeft.add(windowStartLabel);
		windowStartLabel.setBounds(165, 70, 120, 22);
		bottomLeft.add(tf_windowStart);
		tf_windowStart.setBounds(272, 70, 80, 22);
		bottomLeft.add(windowEndLabel);
		windowEndLabel.setBounds(360, 70, 105, 22);
		bottomLeft.add(tf_windowEnd);
		tf_windowEnd.setBounds(465, 70, 80, 22);

		
		//BOTTOMRIGHTPANEL
		JPanel bottomRight = new JPanel();
		bottomRight.setPreferredSize(new Dimension(1101, 120));
		bottomRight.setLayout(null);
		bottomRight.add(buttonPreProcess);
		buttonPreProcess.setBounds(350, 10, 100, 22);
		bottomRight.add(buttonRecover);
		buttonRecover.setBounds(500, 10, 100, 22);
		bottomRight.add(buttonReset);
		buttonReset.setBounds(650, 10, 100, 22);

		add(topLeft);
		add(designPanel1);
		add(topright);
		add(designPanel2);
		add(bottomLeft);
		add(designPanel3);
		add(bottomRight);

		controller.setTopPanel(this);

	}

	public JComboBox createComboBox(int setID) {

		ArrayList<TimeSeries> list = loader.selectTimeSeriesFromSet(setID);
		Vector<Vector> data = new Vector<Vector>();
		for(TimeSeries ts: list) {
			Vector<String> dataElement = new Vector<String>();
			dataElement.add(0, Integer.toString(ts.getTs_id()));
			dataElement.add(1, ts.getDescription());
			data.addElement(dataElement);
		}

		JComboBox combo = new JComboBox(data);
		combo.setSelectedIndex(-1);
		combo.addActionListener(this);
		return combo;
	}

	public void clean() {
		
				temp1.setSelectedIndex(-1);
				hum1.setSelectedIndex(-1);
				air1.setSelectedIndex(-1);
				prec1.setSelectedIndex(-1);
				wind1.setSelectedIndex(-1);
				water1.setSelectedIndex(-1);
				temp2.setSelectedIndex(-1);
				hum2.setSelectedIndex(-1);
				air2.setSelectedIndex(-1);
				prec2.setSelectedIndex(-1);
				wind2.setSelectedIndex(-1);
				water2.setSelectedIndex(-1);

		tsid.setText("");
		tsid.setVisible(false);
		lastTimeStamp.setVisible(false);
		lastTimeStamp.setText("");
		label.setVisible(false);
		buttonReset.setVisible(false);	
		rbPartly.setEnabled(false);
		rbFind.setEnabled(false);
		rbWhole.setSelected(false);
		rbWhole.setEnabled(false);
		rbTestTs.setEnabled(false);
		buttonPreProcess.setEnabled(false);
		buttonRecover.setEnabled(false);
		tf_timeSeriesList.setText("");
		tf_windowStart.setEnabled(false);
		tf_windowEnd.setEnabled(false);
		tf_windowStart.setText("");
		tf_windowEnd.setText("");
		rbTestTs.setSelected(false);
		controller.timeSeriesList.clear();
		buttonFind.setEnabled(false);

		rbPartly.setSelected(false);
		
		labeltemp2.setEnabled(false);
		labelhum2.setEnabled(false);
		labelwind2.setEnabled(false);
		labelprec2.setEnabled(false);
		labelair2.setEnabled(false);
		labelwater2.setEnabled(false);
		temp2.setEnabled(false);
		wind2.setEnabled(false);
		hum2.setEnabled(false);
		prec2.setEnabled(false);
		air2.setEnabled(false);
		water2.setEnabled(false);		
		buttonDelete.setVisible(false);
		controller.cleanlog();
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		JComboBox cb = (JComboBox)e.getSource();
		if (cb.getSelectedIndex() == -1) {
			return;
		} 
		Vector<String> v = (Vector<String>)cb.getSelectedItem();

		if("ref".equals(e.getActionCommand())) {
			controller.refTimeSeriesSelected(v.firstElement());
		} else if ("test".equals(e.getActionCommand())) {
			controller.testTimeSereiesSelected(v.firstElement());
		}


	}

	//public void getDataFromDB() {
	//		
	//		listTemp= loader.selectTimeSeriesFromSet(100);
	//		listHum= loader.selectTimeSeriesFromSet(101);
	//		listPrecip= loader.selectTimeSeriesFromSet(103);
	//		listWind= loader.selectTimeSeriesFromSet(102);
	//		listAir= loader.selectTimeSeriesFromSet(104);
	//		listWater= loader.selectTimeSeriesFromSet(105);
	//	}

}
