package io;

import gui.DecompositionController;

import java.awt.Color;
import java.io.*;
import java.util.StringTokenizer;

import cede.CentroidDecomposition;
import cede.Matrix;


/**
 * Read a matrix (which satisfies the necessery formel constraints) from a .txt file. 
 * Able to save a matrix into a .txt file.
 *
 */

public class ReadFromFile {
	
	DecompositionController decompContr;
	File file;
	CentroidDecomposition cd;
	Matrix m;
	String line;
	BufferedReader inFile;
	FileWriter fw;
	
	public ReadFromFile(DecompositionController decompContr, File file) {
		this.decompContr = decompContr;
		this.file = file;
	}
	
    
	public void readAndDecompose() {
		
		
		try {
			inFile = new BufferedReader(new FileReader(file));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
//			e.printStackTrace();
			decompContr.log("FileNotFoundException", Color.RED);
			
		} 

		try {
			line = inFile.readLine();
		} catch (IOException e) {
			// TODO Auto-generated catch block
//			e.printStackTrace();
			decompContr.log("IOEception", Color.RED);
		}
		
		//get row and colcount
		StringTokenizer firstLineTokens = new StringTokenizer(line, ",", false);
//		try {
		int rows = Integer.parseInt(firstLineTokens.nextToken());
		int cols = Integer.parseInt(firstLineTokens.nextToken());
		
			
		//load values into matrix
		m = new Matrix(rows, cols);
		
		for(int r = 0; r < rows; r++){
			try {
				line = inFile.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
//				e.printStackTrace();
				decompContr.log("IOEception", Color.RED);
			}
			StringTokenizer tokens = new StringTokenizer(line, ",", false);
			
			for(int c = 0; c < cols; c++) {
				m.set(r, c, Float.parseFloat(tokens.nextToken()));
			}
		}
		
		
		
		try {
			inFile.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			decompContr.log("IOEception", Color.RED);
		}
	
		cd = new CentroidDecomposition();
		cd.decompose(m, m.getCols());
		
//		} catch (NumberFormatException e) {
//			decompContr.log("Input matrix has invalid format!", Color.RED);
//		}
		
	}
			
	public void save() {
	//System.out.println(m+"\n\n");
		
		
		try {
			fw = new FileWriter("decomposition.txt");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			decompContr.log("IOEception", Color.RED);
		}  
        PrintWriter pw = new PrintWriter(fw); 
        pw.println("Input matrix: \n\n");
        pw.println(m+"\n\n");
        pw.println("Factor matrix (V): \n\n");
        pw.println(cd.v+"\n\n");   
        pw.println("Loading matrix (B): \n\n");
        pw.println(cd.b+"\n\n");   
        
        pw.close(); 
	}	
		
	public Matrix getFactorMatrix() {
		return cd.v;
	}
	
	public Matrix getLoadingMatrix() {
		return cd.b;
	}
	
	
			
	
	
}

