package preprocessing;

import gui.Controller;

import java.util.ArrayList;
import java.util.Collections;

import model.MeasurePearson;
import cede.Matrix;
import db.DataLoader;

/**
 * Class find the most correlated time series to a given time series.
 */

public class FindCorrelated {
	
	Controller c;
	DataLoader loader = DataLoader.getInstance();

	public int[] findCorreletedTS(int ts_id_recov, int number, Controller c) {

		this.c = c;
		int[] correlatedTimeSeries = new int[number];
		Matrix timeSeriesRecov = loader.extractTimeSeriesData(3000, ts_id_recov);
		ArrayList<MeasurePearson> list = new ArrayList<MeasurePearson>();
		ArrayList<Integer> timeSeriesToCompare = loader.selectTimeSeriesFromSameSets(ts_id_recov);

		for(Integer i: timeSeriesToCompare) {
			if(i != ts_id_recov) {
			Matrix m = loader.extractTimeSeriesData(3000, i);
			double corr = timeSeriesRecov.pearsonCorrelationAbs(m);
			MeasurePearson pearson = new MeasurePearson(i, corr);
			list.add(pearson);
			}
		}

//				printListMeasure(list);

		Collections.sort(list);
		for(int j = 0; j < number; j++) {
			correlatedTimeSeries[j] = list.get(list.size()-1-j).getTs_id();
		}
		

		return correlatedTimeSeries;
	}
	
}
